using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace CSockets
{
    public class ClientEventArgs : EventArgs
    {
        private Socket clientSocket;
        private ClientEvent clientState;

        public Socket ClientSocket
        {
            get { return clientSocket; }
            private set { clientSocket = value; }
        }
        public ClientEvent ClientState
        {
            get { return clientState; }
            set { clientState = value; }
        }

        public ClientEventArgs(Socket Client, ClientEvent state)
            : base()
        {
            ClientSocket = Client;
            ClientState = state;
        }
    }

    public enum ClientEvent
    {
        Connected,
        Disconnected
    }

    public delegate void ClientEventHandler(Object sender, ClientEventArgs e);
}