using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;

namespace CiaoStuff
{
    public static class Serializer
    {
        public static void SaveObject(Object o, String FileName, FormatterType Format)
        {
            if (Format == FormatterType.Binary)
            {
                BinaryFormatter Formatter = new BinaryFormatter();
                Stream fs = File.OpenWrite(FileName);
                Formatter.Serialize(fs, o);
                fs.Close();
            }
            else
            {
                SoapFormatter Formatter = new SoapFormatter();
                Stream fs = File.OpenWrite(FileName);
                Formatter.Serialize(fs, o);
                fs.Close();
            }
        }

        public static Object LoadObject(String FileName, FormatterType Format)
        {
            if (Format == FormatterType.Binary)
            {
                Stream fs = new MemoryStream();
                try
                {
                    BinaryFormatter Formatter = new BinaryFormatter();
                    fs = File.OpenRead(FileName);
                    return Formatter.Deserialize(fs);
                }
                catch
                {
                    return null;
                }
                finally
                {
                    fs.Close();
                }
            }
            else
            {
                Stream fs = new MemoryStream();
                try
                {
                    SoapFormatter Formatter = new SoapFormatter();
                    fs = File.OpenRead(FileName);
                    return Formatter.Deserialize(fs);
                }
                catch
                {
                    return null;
                }
                finally
                {
                    fs.Close();
                }
            }
        }

        public enum FormatterType
        {
            SOAP,
            Binary
        }
    }
}