
#include "stdafx.h"
#include "wmc32.h"
#include "wmc32Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWmc32Dlg dialog

CWmc32Dlg::CWmc32Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWmc32Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWmc32Dlg)
	m_rxText = _T("");
	m_txText = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWmc32Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWmc32Dlg)
	DDX_Control(pDX, IDC_ED_MSG, c_TxText);
	DDX_Control(pDX, IDC_STA_RXTEXT, c_RxText);
	DDX_Text(pDX, IDC_STA_RXTEXT, m_rxText);
	DDX_Text(pDX, IDC_ED_MSG, m_txText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWmc32Dlg, CDialog)
	//{{AFX_MSG_MAP(CWmc32Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUT_SEND, OnButSend)
	ON_WM_COPYDATA()
	ON_BN_CLICKED(IDC_BUT_SEND16, OnButSend16)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWmc32Dlg message handlers

BOOL CWmc32Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	// Build Window id strings
	if (m_appInstance == 1) {
		m_thisAppHeader = "WMC32_1";
		m_otherAppHeader = "WMC32_2";
	} else {					
		m_thisAppHeader = "WMC32_2";
		m_otherAppHeader = "WMC32_1";
	}

	SetWindowText(m_thisAppHeader.GetBuffer(m_thisAppHeader.GetLength()));
	m_thisAppHeader.ReleaseBuffer();

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWmc32Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{

	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CWmc32Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CWmc32Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWmc32Dlg::OnButSend() 
{
	LRESULT copyDataResult;

	CWnd *pOtherWnd = CWnd::FindWindow(NULL, m_otherAppHeader.GetBuffer(m_otherAppHeader.GetLength()));
	m_otherAppHeader.ReleaseBuffer();
	if (pOtherWnd) {
		COPYDATASTRUCT cpd;
		cpd.dwData = 0;
		CString txt;
		c_TxText.GetWindowText(txt);
		cpd.cbData = txt.GetLength();
		cpd.lpData = (void*)txt.GetBuffer(txt.GetLength());
		copyDataResult = pOtherWnd->SendMessage(WM_COPYDATA,
												(WPARAM)AfxGetApp()->m_pMainWnd->GetSafeHwnd(),
												(LPARAM)&cpd);
		txt.ReleaseBuffer();

	} else {
		AfxMessageBox(L"Unable to find other app.");
	}	
}

void CWmc32Dlg::OnButSend16() 
{
	LRESULT copyDataResult;

	CWnd *pOtherWnd = CWnd::FindWindow(NULL, L"WMC16");
	if (pOtherWnd) {
		COPYDATASTRUCT cpd;
		cpd.dwData = 0;
		CString txt;
		c_TxText.GetWindowText(txt);
		cpd.cbData = txt.GetLength();
		cpd.lpData = (void*)txt.GetBuffer(txt.GetLength());
		copyDataResult = pOtherWnd->SendMessage(WM_COPYDATA,
												(WPARAM)AfxGetApp()->m_pMainWnd->GetSafeHwnd(),
												(LPARAM)&cpd);
		txt.ReleaseBuffer();
	} else {
		AfxMessageBox(L"Unable to find other app (16-bit).");
	}
}

BOOL CWmc32Dlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	m_rxText = (LPCSTR)(pCopyDataStruct->lpData);
	c_RxText.SetWindowText(m_rxText);
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}